/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.contabilidad.EntConta;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author obper
 */
@Entity
@Table(name = "horas_anticipo")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "HorasAnticipo.findAll", query = "SELECT h FROM HorasAnticipo h"),
    @NamedQuery(name = "HorasAnticipo.findByCodigoEmpleado", query = "SELECT h FROM HorasAnticipo h WHERE h.codigoEmpleado = :codigoEmpleado"),
    @NamedQuery(name = "HorasAnticipo.findByFecha", query = "SELECT h FROM HorasAnticipo h WHERE h.fecha = :fecha"),
    @NamedQuery(name = "HorasAnticipo.findByHorasDiurnas", query = "SELECT h FROM HorasAnticipo h WHERE h.horasDiurnas = :horasDiurnas"),
    @NamedQuery(name = "HorasAnticipo.findByHorasNocturnas", query = "SELECT h FROM HorasAnticipo h WHERE h.horasNocturnas = :horasNocturnas"),
    @NamedQuery(name = "HorasAnticipo.findByAnticipo", query = "SELECT h FROM HorasAnticipo h WHERE h.anticipo = :anticipo"),
    @NamedQuery(name = "HorasAnticipo.findByDiasDescuento", query = "SELECT h FROM HorasAnticipo h WHERE h.diasDescuento = :diasDescuento"),
    @NamedQuery(name = "HorasAnticipo.findByTurnos", query = "SELECT h FROM HorasAnticipo h WHERE h.turnos = :turnos"),
    @NamedQuery(name = "HorasAnticipo.findByFechaxtra", query = "SELECT h FROM HorasAnticipo h WHERE h.fechaxtra = :fechaxtra"),
    @NamedQuery(name = "HorasAnticipo.findById", query = "SELECT h FROM HorasAnticipo h WHERE h.id = :id")})
public class HorasAnticipo implements Serializable {

    private static final long serialVersionUID = 1L;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 3)
    @Column(name = "codigo_empleado")
    private String codigoEmpleado;
    @Basic(optional = false)
    @NotNull
    @Column(name = "fecha")
    @Temporal(TemporalType.DATE)
    private Date fecha;
    // @Max(value=?)  @Min(value=?)//if you know range of your decimal fields consider using these annotations to enforce field validation
    @Basic(optional = false)
    @NotNull
    @Column(name = "horas_diurnas")
    private BigDecimal horasDiurnas;
    @Basic(optional = false)
    @NotNull
    @Column(name = "horas_nocturnas")
    private BigDecimal horasNocturnas;
    @Basic(optional = false)
    @NotNull
    @Column(name = "anticipo")
    private BigDecimal anticipo;
    @Basic(optional = false)
    @NotNull
    @Column(name = "dias_descuento")
    private BigDecimal diasDescuento;
    @Basic(optional = false)
    @NotNull
    @Column(name = "turnos")
    private BigDecimal turnos;
    @Column(name = "fechaxtra")
    @Temporal(TemporalType.DATE)
    private Date fechaxtra;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "ID")
    private Integer id;

    public HorasAnticipo() {
    }

    public HorasAnticipo(Integer id) {
        this.id = id;
    }

    public HorasAnticipo(Integer id, String codigoEmpleado, Date fecha, BigDecimal horasDiurnas, BigDecimal horasNocturnas, BigDecimal anticipo, BigDecimal diasDescuento, BigDecimal turnos) {
        this.id = id;
        this.codigoEmpleado = codigoEmpleado;
        this.fecha = fecha;
        this.horasDiurnas = horasDiurnas;
        this.horasNocturnas = horasNocturnas;
        this.anticipo = anticipo;
        this.diasDescuento = diasDescuento;
        this.turnos = turnos;
    }

    public String getCodigoEmpleado() {
        return codigoEmpleado;
    }

    public void setCodigoEmpleado(String codigoEmpleado) {
        this.codigoEmpleado = codigoEmpleado;
    }

    public Date getFecha() {
        return fecha;
    }

    public void setFecha(Date fecha) {
        this.fecha = fecha;
    }

    public BigDecimal getHorasDiurnas() {
        return horasDiurnas;
    }

    public void setHorasDiurnas(BigDecimal horasDiurnas) {
        this.horasDiurnas = horasDiurnas;
    }

    public BigDecimal getHorasNocturnas() {
        return horasNocturnas;
    }

    public void setHorasNocturnas(BigDecimal horasNocturnas) {
        this.horasNocturnas = horasNocturnas;
    }

    public BigDecimal getAnticipo() {
        return anticipo;
    }

    public void setAnticipo(BigDecimal anticipo) {
        this.anticipo = anticipo;
    }

    public BigDecimal getDiasDescuento() {
        return diasDescuento;
    }

    public void setDiasDescuento(BigDecimal diasDescuento) {
        this.diasDescuento = diasDescuento;
    }

    public BigDecimal getTurnos() {
        return turnos;
    }

    public void setTurnos(BigDecimal turnos) {
        this.turnos = turnos;
    }

    public Date getFechaxtra() {
        return fechaxtra;
    }

    public void setFechaxtra(Date fechaxtra) {
        this.fechaxtra = fechaxtra;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof HorasAnticipo)) {
            return false;
        }
        HorasAnticipo other = (HorasAnticipo) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.contabilidad.EntConta.HorasAnticipo[ id=" + id + " ]";
    }
    
}
